--[[
-- Alternative Control Scheme
-- MISI MOD for GTA2
--
-- Author: Dege
-- Date: 04 apr 2018
-- Mod version: v0.3
-- MISI since version: v0.3.3b
-- Description: Use the arrows to walk in the arrow's direction
]]--


function manageInputs(isInCar, isWalking)
	local input_status = ReadProcessMemory(0x5ecacc, 1)
	if(isInCar) then
		if(IsKeyPress(0x26)) then --up-forward
			input_status = input_status | 0x01
		else
			input_status = input_status & 0xFE
		end
		if(IsKeyPress(0x28)) then --down-backwards
			input_status = input_status | 0x02
		else
			input_status = input_status & 0xFD
		end
		if(IsKeyPress(0x25)) then --left-left
			input_status = input_status | 0x04
		else
			input_status = input_status & 0xFB
		end
		if(IsKeyPress(0x27)) then --right-right
			input_status = input_status | 0x08
		else
			input_status = input_status & 0xF7
		end
	else
		--remove natural movement inputs
		input_status = input_status & 0xF0
		if(isWalking) then
			input_status = input_status | 0x01
		end
	end
	if(IsKeyPress(0x11)) then --ctrl-attack
		input_status = input_status | 0x10
	else
		input_status = input_status & 0xEF
	end
	if(IsKeyPress(0x0D)) then --enter-enter/exit
		input_status = input_status | 0x20
	else
		input_status = input_status & 0xDF
	end
	if(IsKeyPress(0x20)) then --space-handbrake/jump
		input_status = input_status | 0x40
	else
		input_status = input_status & 0xBF
	end
	if(IsKeyPress(0x5A)) then --Z-previous weapon
		input_status = input_status | 0x80
	else
		input_status = input_status & 0x7F
	end
	WriteProcessMemory(0x5ecacc, input_status, 1)
end

local gamestate = 0
local ped = 0
local walk_speed = 256

while(true) do
	if (GetGameFrame() > 0) then
		if (gamestate == 0) then -- If start new game
			wait(100)
			for i = 1, 6, 1 do
				ped = GetPedStruct(i)
				x, y, z = GetPedPos(ped)
				if (GetPedRangeOfPoint(ped, x, y, z) <= 0.5) then
					 --WriteInLog(string.format("ped index %d id %d struct %X\n",i,GetPedID(ped),ped))
					 break
				end
			end
			gamestate = 1
		end
		if (gamestate == 1 and ped ~= 0) then
			local isInCar = ReadProcessMemory(0x5e20bc, 1) ~= 0
			local isWalking = false
			if ((not isInCar) and (IsKeyPress(0x25) or IsKeyPress(0x26) or IsKeyPress(0x27) or IsKeyPress(0x28))) then
				local vertical = 0;
				local horizontal = 0;
				--up
				if (IsKeyPress(0x26)) then
					vertical = vertical + 1;
				end
				--down
				if (IsKeyPress(0x28)) then
					vertical = vertical - 1;
				end
				--right
				if (IsKeyPress(0x27)) then
					horizontal = horizontal + 1;
				end
				--left
				if (IsKeyPress(0x25)) then
					horizontal = horizontal - 1;
				end
				if(vertical ~= 0 or horizontal ~= 0) then
					local angle = math.deg(math.atan(vertical, horizontal)) + 90
					if(angle < 0) then
						angle = angle + 360
					end
					SetPedAngle(ped, angle)
					isWalking = true
				end
			end
			manageInputs(isInCar, isWalking)
		end
	else
		gamestate = 0 -- If not frame to game restart or game not loaded
	end
end